
 //ac:pinout
 
  //ac:DHT22
 
//MikroC et 16F84
// C:\_MikroC\_MesProjets_MikroC\_16F84_DHT22_UART3_9600bds
// P16F84_4MHz_blueBird_board.cfgsch
//  P16F84_8MHz.cfgsch  (sur mini breadbboard orange  )
//  CONFIG : $2007 : 0x3FF1

// 16F84 #  84-0045-04
// Resonateur 4Mhz sur platine de test BlueBoard-Electronics Farnell 527-646
// sortie TX sur RA2
// sortie Led sur RA3
// signal DHT22 sur RA0
// ICProgr  + POK508 programmateur   (alim POK508  + TU59 DB8<-> USB  COM2
// nota: prends ENORMEMENT de temps  programmer !! > 5minutes

// sur breadboard  Q=8MHz   16F84 0130G38-20
// EEPROM PIC : _16F84_DHT22_UART3_9600bds_2024_0712.ihex

 #define VERSION "2024-0712"

 #define CR 13
 #define LF 10
 #define  LED_Dir     TRISA.RA3
 #define  LED        PORTA.RA3
 #define bit_set(var,bitno) ((var) |= 1 << (bitno))
 #define bit_clear(var,bitno) ((var) &= ~(1 << (bitno)))

 #define DHT22_Pin  PORTA.RA0
#define  DHT22_Pin_Dir  TRISA.RA0


 // Lcd pinout settings  
 // Special RETRAITE128 FANTASPIC
 // https://fantaspic.fr/viewtopic.php?f=10&p=22172#p22172
 
#define  RETRAITE128
 
#ifdef  RETRAITE128

sbit LCD_RS at RB0_bit;
sbit LCD_EN at RB2_bit;
sbit LCD_D7 at RB6_bit;
sbit LCD_D6 at RB5_bit;
sbit LCD_D5 at RB4_bit;
sbit LCD_D4 at RB3_bit;

#else
// Lcd pinout settings   standard

sbit LCD_RS at RB0_bit;
sbit LCD_EN at RB2_bit;
sbit LCD_D7 at RB7_bit;
sbit LCD_D6 at RB6_bit;
sbit LCD_D5 at RB5_bit;
sbit LCD_D4 at RB4_bit;


#endif


 // Special RETRAITE128 FANTASPIC
 #ifdef  RETRAITE128
 // Pin direction
// LCD 4x20  mode 4 bits MSB   4 bits data LSB -> Gnd
// pin    1 ....2....3.....4.....5....6....x...x...x...x...11...12...13....14
//        Gnd  +Vcc Vd    RB0  RB1  RB2  Gnd Gnd Gnd  Gnd  RB3  RB4  RB5   RB6.
// retro eclairage  15=A->+Vcc  16=K  R 390 ohms->Gnd/
// contraste fixe  Pin 3 R=4.7K vers Gnd
 sbit LCD_RS_Direction at TRISB0_bit;
sbit LCD_EN_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB6_bit;
sbit LCD_D6_Direction at TRISB5_bit;
sbit LCD_D5_Direction at TRISB4_bit;
sbit LCD_D4_Direction at TRISB3_bit;
#else
// Pin direction
// LCD 4x20  mode 4 bits MSB   4 bits data LSB -> Gnd
// pin    1 ....2....3.. 4.....5....6....x...x...x...x...11..12...13..14
//        Gnd  +Vcc Vd  RB0  RB1  RB2  Gnd Gnd Gnd Gnd  RB4  RB5 RB6 RB7
// retro eclairage  15=A->+Vcc  16=K  R 390 ->Gnd/
// standard

sbit LCD_RS_Direction at TRISB0_bit;
sbit LCD_EN_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB7_bit;
sbit LCD_D6_Direction at TRISB6_bit;
sbit LCD_D5_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB4_bit;
#endif

 char Texte[18];
 int i,j,k;

unsigned char Time_out ;
unsigned char T_byte1, T_byte2, RH_byte1, RH_byte2, CheckSum ;
unsigned int Temp, RH;

void strConstRamCpy(unsigned char *dest, const char *source);
void Start_signal(void);
char check_response(void);
unsigned char Read_Donnee(void);


void Delai()
  {
      Delay_ms(500);
 }


void Start_signal()
{
  DHT22_Pin_Dir = 0;              // Configure connection pin as output
  DHT22_Pin = 0;                        // Connection pin output low
  Delay_ms(25);
  DHT22_Pin = 1;                        // Connection pin output high
  Delay_us(30);
  DHT22_Pin_Dir = 1;              // Configure connection pin as input
}


char check_response()
{
  Delay_us(40);
  if(DHT22_Pin==0)
  {                     // Read and test if connection pin is low
    Delay_us(80);
    if(DHT22_Pin==1)
    {                    // Read and test if connection pin is high
      Delay_us(50);
      return 1;
      }
    }
}
unsigned char Read_Donnee()
{
  unsigned char i, k, value;     // k is used to count 1 bit reading duration
  value=0;
  Time_out=0;
  for(i = 0; i < 8; i++)
  { k = 0;
    while(  PORTA.B0==0)
    {  k++;
      if (k > 100) 
      {Time_out = 1;
        break;
       }
      Delay_us(1);
     }
  Delay_us(30);
    if(  PORTA.B0==0)
      bit_clear(value, (7 - i));               // Clear bit (7 - i)
    else
    {
      bit_set(value, (7 - i));                 // Set bit (7 - i)
      k=0;
       while(  PORTA.B0==1)
      {                         // Wait until pin goes low
      k++;
      if (k > 100) 
      {Time_out = 1;
       break;
       }
     Delay_us(1);
     }
    }
  }
  return (value);
}

  void strConstRamCpy(unsigned char *dest, const char *source)
 { // --- Copie le texte depuis FLASH ROM vers RAM
  while (*(source)>0)
  {
      *dest++ = *source++ ;
  }
  *dest = 0 ;    // terminateur
}

void main()
 {

 TRISB = 0b00000000 ;  // RB0,RB1,RB2  inputs  RB3,RB4=sorties  RB6,RB7 =entrees
 TRISA = 0b00000001 ;   // RA0,RA1 = Input RA2=TX ouput  RA3=Sortie Led  RA5..RA7=Entrees
 //INTCON=0;
 PORTA=0;
 DHT22_Pin_Dir=0;
 DHT22_Pin=0;
  LED_Dir=0;
  LED=0;
  Time_out=0;
  for(i=0;i<6;i++)
   {
   LED=0;
      Delai() ;
    LED=1;
      Delai()  ;
   }
  Lcd_Init();
     Lcd_Cmd(_LCD_CLEAR);               // Clear display
    Lcd_Cmd(_LCD_CURSOR_OFF);
     strConstRamCpy(Texte,"DHT22 16F84 8MHz");
    Lcd_Out(1,1,Texte);
   strConstRamCpy(Texte,"MikroC 7.60 Pro ");
    Lcd_Out(2,1,Texte);
   strConstRamCpy(Texte,"Version 13-07-24");
   Lcd_Out(3,1,Texte);
    Delai()  ; Delai()  ;
     Lcd_Cmd(_LCD_CLEAR);
 //while(1);

  while(1)
  {
    Start_signal();
  //  Lcd_Out_CP('1');
    if(check_response())
    {                    // If there is response from sensor
      RH_byte1 = Read_Donnee();                 // read RH byte1
      RH_byte2 = Read_Donnee();                 // read RH byte2
      T_byte1 = Read_Donnee();                  // read T byte1
      T_byte2 = Read_Donnee();                  // read T byte2
      CheckSum = Read_Donnee();                 // read checksum
      if(Time_out){                           // If reading takes long time
         strConstRamCpy(Texte,"Time out!");
         Lcd_Out(1,1,Texte);

      }
      else
      {
       if(CheckSum == ((RH_byte1 + RH_byte2 + T_byte1 + T_byte2) & 0xFF))
       {
        strConstRamCpy(Texte,"Temp = 00.0 C   ");
        RH = RH_byte1;
        RH = (RH << 8) | RH_byte2;
        Temp = T_byte1;
        Temp = (Temp << 8) | T_byte2;
         if (Temp > 0x8000)
         {
         Texte[6] = '-';
         Temp = Temp & 0x7FFF;
          }
         else
         Texte[6] = ' ';
        
         Texte[7]  = (Temp / 100) % 10  + 48;
         Texte[8]  = (Temp / 10) % 10  + 48;
         Texte[10] = Temp % 10  + 48;
         Texte[11] = 223;                   // Degree symbol
         Lcd_Out(1,1,Texte);
         strConstRamCpy(Texte,"RH   = 00.0 %   ");
         Texte[7]  = (RH / 100) % 10 + 48;
         Texte[8]  = (RH / 10) % 10 + 48;
         Texte[10] = RH % 10 + 48;
         Lcd_Out(2,1,Texte);
       }
        else 
       {
           strConstRamCpy(Texte,"Checksum Error!");
           Lcd_Out(2,1,Texte);
        }
      }
    }
    else 
    {
       strConstRamCpy(Texte,"Pas de reponse..");
        Lcd_Out(2,1,Texte);
         Delai() ;
    }
    Delai() ;
  }
 }

 /*
 
    All files Compiled in 93 ms
 Used RAM (bytes): 38 (73%)  Free RAM (bytes): 14 (27%) Used RAM (bytes)
 Used ROM (program words): 950 (93%)  Free ROM (program words)  74 (7%)

0 1 mikroCPIC1618.exe -MSF -DBG -pP16F84 -RA -LHF -C -O11111014 -fo8 -EH"C:\_MikroC\_MesProjets_MikroC\_16F84_DHT22_LCD_2024\_16F84_DHT22_UART3_9600bds_2024_0712.ihex" -N"C:\_MikroC\_MesProjets_MikroC\_16F84_DHT22_LCD_2024\_16F84_DHT22_LCD_2024.mcppi" -SP"C:\_MikroC\mikroC PRO for PIC\Defs\" -SP"C:\_MikroC\mikroC PRO for PIC\Uses\P16\" -SP"C:\_MikroC\_MesProjets_MikroC\_16F84_DHT22_LCD_2024\" -SP"C:\_MikroC\_MesProjets_MikroC\__common\" -IP"C:\_MikroC\mikroC PRO for PIC\Uses\P16\" "_16F84_DHT22_LCD2x16_MC.c" "__Lib_Math.mcl" "__Lib_MathDouble.mcl" "__Lib_System.mcl" "__Lib_Delays.mcl" "__Lib_CType.mcl" "__Lib_CString.mcl" "__Lib_CStdlib.mcl" "__Lib_LcdConsts.mcl" "__Lib_Lcd.mcl"
0 1139 Available RAM: 52 [bytes], Available ROM: 1024 [bytes]
0 122 Compilation Started P16F84.c
187 123 Compiled Successfully P16F84.c
0 122 Compilation Started __Lib_Delays.c
123 123 Compiled Successfully __Lib_Delays.c
0 122 Compilation Started _16F84_DHT22_LCD2x16_MC.c
275 123 Compiled Successfully _16F84_DHT22_LCD2x16_MC.c
0 127 All files Compiled in 93 ms
0 1144 Used RAM (bytes): 38 (73%)  Free RAM (bytes): 14 (27%) Used RAM (bytes): 38 (73%)  Free RAM (bytes): 14 (27%)
0 1144 Used ROM (program words): 950 (93%)  Free ROM (program words): 74 (7%) Used ROM (program words): 950 (93%)  Free ROM (program words): 74 (7%)
0 125 Project Linked Successfully _16F84_DHT22_LCD_2024.mcppi
0 128 Linked in 16 ms
0 129 Project '_16F84_DHT22_LCD_2024.mcppi' completed: 297 ms
0 103 Finished successfully: 13 juil. 2024, 17:50:11 _16F84_DHT22_LCD_2024.mcppi


  */